function Mdl = executeECOC_SVMTraining(X, Y, coding, ordinalOrder)
%EXECUTEECOC_SVMTrainingTB Executes multiple SVM training
% accorcing to the ECOC model for multiclass classification using the
% methods given by the MATLAB Statistics and Machine Learning Toolbox
% Also performs k-fold cross validation
% X: table containing the data with samples in rows and features in
% columns.
% Y: Categorical array or cell array containing the target categories
% ordinalOrder (optional): cell array containint the order of classes
% for ordinal separation
% Prerequisits: Access to the MATLAB Statistics and Machine Learning
% Toolbox

   try
     Xarray = table2array(X);
   catch
     Xarray = X;
   end
    Ycategories = categorical(Y);
    Ycellarray = cellstr(Y);
    
    if ~exist('ordinalOrder','var')
        ordinalOrder = categories(Ycategories);
    end
    
   t = templateSVM('BoxConstraint',1000);
   Mdl = fitcecoc(Xarray,Ycellarray,...
        'Learners',t,'Coding',coding,...
        'ClassNames',ordinalOrder);
end